Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/RepositoryController.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/RepositoryController.java	(revision 61440)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/RepositoryController.java	(revision 61441)
@@ -3,14 +3,19 @@
 import eu.dnetlib.domain.data.Repository;
 import eu.dnetlib.domain.data.RepositoryInterface;
 import eu.dnetlib.repo.manager.domain.*;
+import eu.dnetlib.repo.manager.domain.dto.User;
 import eu.dnetlib.repo.manager.exception.ResourceNotFoundException;
-import eu.dnetlib.repo.manager.service.RepositoryServiceImpl;
+import eu.dnetlib.repo.manager.service.RepositoryService;
+import eu.dnetlib.repo.manager.service.security.AuthorizationService;
+import eu.dnetlib.repo.manager.utils.JsonUtils;
 import io.swagger.annotations.Api;
 import org.apache.log4j.Logger;
 import org.json.JSONException;
 import org.mitre.openid.connect.model.OIDCAuthenticationToken;
 import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.http.HttpStatus;
 import org.springframework.http.MediaType;
+import org.springframework.http.ResponseEntity;
 import org.springframework.security.access.prepost.PostAuthorize;
 import org.springframework.security.access.prepost.PreAuthorize;
 import org.springframework.security.core.Authentication;
@@ -17,21 +22,29 @@
 import org.springframework.security.core.context.SecurityContextHolder;
 import org.springframework.web.bind.annotation.*;
 
+import javax.ws.rs.core.Response;
 import java.io.IOException;
 import java.util.List;
 import java.util.Map;
 
 @RestController
-@RequestMapping(value = "/repository")
-@Api(description = "Repository API",  tags = {"repository"})
+@RequestMapping(value = "/repositories")
+@Api(description = "Repository API", tags = {"repositories"})
 public class RepositoryController {
 
-    private static Logger logger = Logger.getLogger(RepositoryController.class);
+    private static final Logger logger = Logger.getLogger(RepositoryController.class);
 
+    private final RepositoryService repositoryService;
+    private final AuthorizationService authorizationService;
+
     @Autowired
-    private RepositoryServiceImpl repositoryService;
+    RepositoryController(RepositoryService repositoryService,
+                         AuthorizationService authorizationService) {
+        this.repositoryService = repositoryService;
+        this.authorizationService = authorizationService;
+    }
 
-    @RequestMapping(value = "/getCountries", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
+    @RequestMapping(value = "/countries", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
     public Country[] getCountries() {
         return repositoryService.getCountries();
@@ -42,28 +55,26 @@
     @ResponseBody
     public List<RepositorySnippet> getRepositoriesByCountry(@PathVariable("country") String country,
                                                             @PathVariable("mode") String mode,
-                                                            @RequestParam(value = "managed",required=false) Boolean managed) throws JSONException, IOException {
+                                                            @RequestParam(value = "managed", required = false) Boolean managed) throws JSONException, IOException {
         return repositoryService.getRepositoriesByCountry(country, mode, managed);
     }
 
-    @RequestMapping(value = "/getRepositoriesOfUser/{page}/{size}",method = RequestMethod.GET,
+    @RequestMapping(value = "/snippets/user", method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_USER')")
-    public List<RepositorySnippet> getRepositoriesOfUser(
-                                                  @PathVariable("page") String page,
-                                                  @PathVariable("size") String size) throws JSONException, IOException {
-       return repositoryService.getRepositoriesSnippetOfUser(((OIDCAuthenticationToken) SecurityContextHolder.getContext().getAuthentication()).getUserInfo().getEmail(), page, size);
+    @PreAuthorize("hasAuthority('REGISTERED_USER')")
+    public List<RepositorySnippet> getRepositoriesSnippetsOfUser() throws Exception {
+        return repositoryService.getRepositoriesSnippetsOfUser("0", "100");
     }
 
-    @RequestMapping(value = "/searchRegisteredRepositories/{page}/{size}",method = RequestMethod.GET,
+    @RequestMapping(value = "/searchRegisteredRepositories/{page}/{size}", method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_ADMIN') or hasRole('ROLE_PROVIDE_ADMIN')")
-    public List<RepositorySnippet> searchRegisteredRepositories(@RequestParam(name="country", required=false) String country,
-                                                                @RequestParam(name="typology", required=false) String typology,
-                                                                @RequestParam(name="englishName", required=false) String englishName,
-                                                                @RequestParam(name="officialName", required=false) String officialName,
+    @PreAuthorize("hasAuthority('SUPER_ADMINISTRATOR') or hasAuthority('CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR')")
+    public List<RepositorySnippet> searchRegisteredRepositories(@RequestParam(name = "country", required = false) String country,
+                                                                @RequestParam(name = "typology", required = false) String typology,
+                                                                @RequestParam(name = "englishName", required = false) String englishName,
+                                                                @RequestParam(name = "officialName", required = false) String officialName,
                                                                 @RequestParam("requestSortBy") String requestSortBy,
                                                                 @RequestParam("order") String order,
                                                                 @PathVariable("page") int page,
@@ -75,14 +86,14 @@
     @RequestMapping(value = "/getRepositoryById/{id}", method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PostAuthorize("hasRole('ROLE_ADMIN') or hasRole('ROLE_PROVIDE_ADMIN') or ((returnObject.registeredBy=='null' or returnObject.registeredBy==authentication.userInfo.email) and hasRole('ROLE_USER'))")
-    public Repository getRepositoryById(@PathVariable("id") String id) throws JSONException,ResourceNotFoundException {
+    @PostAuthorize("hasAnyRole('SUPER_ADMINISTRATOR', 'CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR') or @authorizationService.isMemberOf(#id) or (returnObject.registeredBy=='null' and hasAuthority('REGISTERED_USER'))")
+    public Repository getRepositoryById(@PathVariable("id") String id) throws JSONException, ResourceNotFoundException {
         Repository repo = repositoryService.getRepositoryById(id);
 
-	if (repo != null)
-        	logger.info("Returning repository " + repo.getId() + " registered by " + repo.getRegisteredBy());
-	else
-		logger.info("Requested repository " + id  + " not found");
+        if (repo != null)
+            logger.info("Returning repository " + repo.getId() + " registered by " + repo.getRegisteredBy());
+        else
+            logger.info("Requested repository " + id + " not found");
         return repo;
     }
 
@@ -90,7 +101,7 @@
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
     public List<AggregationDetails> getRepositoryAggregations(@PathVariable("id") String id) throws JSONException {
-        return repositoryService.getRepositoryAggregations(id,0,20);
+        return repositoryService.getRepositoryAggregations(id, 0, 20);
     }
 
     @RequestMapping(value = "/getRepositoryAggregationsByYear/{id}", method = RequestMethod.GET,
@@ -112,7 +123,7 @@
     @RequestMapping(value = "/getRepositoryInterface/{id}", method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PostAuthorize("hasRole('ROLE_ADMIN') or hasRole('ROLE_PROVIDE_ADMIN') or ((@repositoryService.getRepositoryById(#id).registeredBy==authentication.userInfo.email or @repositoryService.getRepositoryById(#id).registeredBy=='null' ) and hasRole('ROLE_USER'))")
+    @PostAuthorize("hasAuthority('SUPER_ADMINISTRATOR') or hasAuthority('CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR') or @authorizationService.isMemberOf(#id) or (@repositoryService.getRepositoryById(#id).registeredBy=='null' and hasAuthority('REGISTERED_USER'))")
     public List<RepositoryInterface> getRepositoryInterface(@PathVariable("id") String id) throws JSONException {
         return repositoryService.getRepositoryInterface(id);
     }
@@ -120,7 +131,8 @@
     @RequestMapping(value = "/addRepository", method = RequestMethod.POST,
             consumes = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_ADMIN') or hasRole('ROLE_PROVIDE_ADMIN') or ((#repository.registeredBy==authentication.userInfo.email or returnObject.registeredBy=='null') and hasRole('ROLE_USER'))")
+//    @PreAuthorize("hasAuthority('SUPER_ADMINISTRATOR') or hasAuthority('CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR') or (hasAuthority(@authorizationService.convertRepoIdToRoleId(#repository.id)) or hasAuthority(@authorizationService.convertRepoIdToRoleId(returnObject.id)))")
+    @PreAuthorize("hasAuthority('SUPER_ADMINISTRATOR') or hasAuthority('CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR') or hasAuthority('REGISTERED_USER')")
     public Repository addRepository(@RequestParam("datatype") String datatype,
                                     @RequestBody Repository repository) throws Exception {
 
@@ -130,7 +142,7 @@
     @RequestMapping(value = "/getDnetCountries", method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    public List<String> getDnetCountries(){
+    public List<String> getDnetCountries() {
         return repositoryService.getDnetCountries();
     }
 
@@ -137,7 +149,7 @@
     @RequestMapping(value = "/getTypologies", method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    public List<String> getTypologies(){
+    public List<String> getTypologies() {
         return repositoryService.getTypologies();
     }
 
@@ -144,7 +156,7 @@
     @RequestMapping(value = "/getTimezones", method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    public List<Timezone> getTimezones(){
+    public List<Timezone> getTimezones() {
         return repositoryService.getTimezones();
     }
 
@@ -151,15 +163,15 @@
     @RequestMapping(value = "/updateRepository", method = RequestMethod.POST,
             consumes = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_ADMIN') or hasRole('ROLE_PROVIDE_ADMIN') or ((#repository.registeredBy==authentication.userInfo.email or #repository.registeredBy=='null') and hasRole('ROLE_USER'))")
-    public Repository updateRepository(@RequestBody Repository repository,Authentication authentication) throws Exception {
+    @PreAuthorize("hasAuthority('SUPER_ADMINISTRATOR') or hasAuthority('CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR') or @authorizationService.isMemberOf(#repository.id)")
+    public Repository updateRepository(@RequestBody Repository repository, Authentication authentication) throws Exception {
         return repositoryService.updateRepository(repository, authentication);
     }
 
     @RequestMapping(value = "/deleteInterface/", method = RequestMethod.DELETE)
-    @PreAuthorize("hasRole('ROLE_USER') and #registeredBy == authentication.userInfo.email")
-    public void deleteRepositoryInterface(@RequestParam("id") String id ,
-                                          @RequestParam("registeredBy") String registeredBy){
+    @PreAuthorize("@authorizationService.isMemberOf(#id)")
+    public void deleteRepositoryInterface(@RequestParam("id") String id,
+                                          @RequestParam("registeredBy") String registeredBy) {
         repositoryService.deleteRepositoryInterface(id, registeredBy);
     }
 
@@ -166,58 +178,56 @@
     @RequestMapping(value = "/addInterface", method = RequestMethod.POST,
             consumes = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_ADMIN') or hasRole('ROLE_PROVIDE_ADMIN') or ((@repositoryService.getRepositoryById(#repoId).registeredBy==authentication.userInfo.email or @repositoryService.getRepositoryById(#repoId).registeredBy=='null') and hasRole('ROLE_USER'))")
+    @PreAuthorize("hasAuthority('SUPER_ADMINISTRATOR') or hasAuthority('CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR') or @authorizationService.isMemberOf(#id)")
     public RepositoryInterface addRepositoryInterface(@RequestParam("datatype") String datatype,
-                                                      @RequestParam("repoId") String repoId,
+                                                      @RequestParam("id") String id,
                                                       @RequestParam("registeredBy") String registeredBy,
                                                       @RequestParam(value = "comment", required = false) String comment,
                                                       @RequestBody RepositoryInterface repositoryInterface) throws Exception {
-        return repositoryService.addRepositoryInterface(datatype, repoId, registeredBy, comment, repositoryInterface);
+        return repositoryService.addRepositoryInterface(datatype, id, registeredBy, comment, repositoryInterface);
     }
 
-    @RequestMapping(value = "/getUrlsOfUserRepos/{page}/{size}/",method = RequestMethod.GET,
+    @RequestMapping(value = "/getUrlsOfUserRepos/{page}/{size}/", method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_USER')")
-    public List<String> getUrlsOfUserRepos(
-                                           @PathVariable("page") String page,
-                                           @PathVariable("size") String size) throws JSONException {
+    @PreAuthorize("hasAuthority('REGISTERED_USER')")
+    public List<String> getUrlsOfUserRepos(@PathVariable("page") String page, @PathVariable("size") String size) {
         return repositoryService.getUrlsOfUserRepos(((OIDCAuthenticationToken) SecurityContextHolder.getContext().getAuthentication()).getUserInfo().getEmail(), page, size);
     }
 
-    @RequestMapping(value = "/getDatasourceVocabularies/{mode}",method = RequestMethod.GET,
+    @RequestMapping(value = "/getDatasourceVocabularies/{mode}", method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
     public List<String> getDatasourceVocabularies(@PathVariable("mode") String mode) {
-       return repositoryService.getDatasourceVocabularies(mode);
+        return repositoryService.getDatasourceVocabularies(mode);
     }
 
-    @RequestMapping(value = "/getCompatibilityClasses/{mode}",method = RequestMethod.GET,
+    @RequestMapping(value = "/getCompatibilityClasses/{mode}", method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    public Map<String, String> getCompatibilityClasses(@PathVariable("mode") String mode)  {
+    public Map<String, String> getCompatibilityClasses(@PathVariable("mode") String mode) {
 
         return repositoryService.getCompatibilityClasses(mode);
     }
 
-    @RequestMapping(value = "/getDatasourceClasses/{mode}",method = RequestMethod.GET,
+    @RequestMapping(value = "/getDatasourceClasses/{mode}", method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    public Map<String, String> getDatasourceClasses(@PathVariable("mode") String mode)  {
-       return repositoryService.getDatasourceClasses(mode);
+    public Map<String, String> getDatasourceClasses(@PathVariable("mode") String mode) {
+        return repositoryService.getDatasourceClasses(mode);
     }
 
-    @RequestMapping(value = "/getMetricsInfoForRepository/{repoId}",method = RequestMethod.GET,
+    @RequestMapping(value = "/getMetricsInfoForRepository/{id}", method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    public MetricsInfo getMetricsInfoForRepository(@PathVariable("repoId")  String repoId) throws RepositoryServiceException {
-        return repositoryService.getMetricsInfoForRepository(repoId);
+    public MetricsInfo getMetricsInfoForRepository(@PathVariable("id") String id) throws RepositoryServiceException {
+        return repositoryService.getMetricsInfoForRepository(id);
     }
 
-    @RequestMapping(value = "/getListLatestUpdate/{mode}",method = RequestMethod.GET,
+    @RequestMapping(value = "/getListLatestUpdate/{mode}", method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    public Map<String, String> getListLatestUpdate(@PathVariable("mode")  String mode) throws JSONException {
+    public Map<String, String> getListLatestUpdate(@PathVariable("mode") String mode) throws JSONException {
         return repositoryService.getListLatestUpdate(mode);
     }
 
@@ -224,11 +234,44 @@
     @RequestMapping(value = "/updateRepositoryInterface", method = RequestMethod.POST,
             consumes = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_ADMIN') or hasRole('ROLE_PROVIDE_ADMIN') or ((@repositoryService.getRepositoryById(#repoId).registeredBy==authentication.userInfo.email or @repositoryService.getRepositoryById(#repoId).registeredBy=='null') and hasRole('ROLE_USER'))")
-    public RepositoryInterface updateRepositoryInterface(@RequestParam("repoId") String repoId,
+    @PreAuthorize("hasAuthority('SUPER_ADMINISTRATOR') or hasAuthority('CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR') or @authorizationService.isMemberOf(#id)")
+    public RepositoryInterface updateRepositoryInterface(@RequestParam("id") String id,
                                                          @RequestParam("registeredBy") String registeredBy,
                                                          @RequestParam(value = "comment", required = false) String comment,
                                                          @RequestBody RepositoryInterface repositoryInterface) throws Exception {
-        return repositoryService.updateRepositoryInterface(repoId, registeredBy, comment, repositoryInterface);
+        return repositoryService.updateRepositoryInterface(id, registeredBy, comment, repositoryInterface);
     }
+
+
+    ///////////////////////////////////////////////////////////////////////////////////////////////////////////
+    ///////////////////////////////////////////////////////////////////////////////////////////////////////////
+
+    /**
+     * Get all the admins of the repository
+     */
+    @RequestMapping(method = RequestMethod.GET, path = "{id}/admins")
+    @PreAuthorize("hasAnyAuthority('SUPER_ADMINISTRATOR', 'CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR') or @authorizationService.isMemberOf(#id)")
+    public ResponseEntity<List<User>> getAdminsOfARepo(@PathVariable("id") String id) {
+        return new ResponseEntity<>(authorizationService.getAdminsOfRepo(id), HttpStatus.OK);
+    }
+
+    /**
+     * Subscribe to repo by email
+     */
+    @RequestMapping(method = RequestMethod.POST, path = "{id}/admins")
+    @PreAuthorize("hasAnyAuthority('SUPER_ADMINISTRATOR', 'CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR') or @authorizationService.isMemberOf(#id)")
+    public Response subscribeByEmail(@PathVariable("id") String id, @RequestBody String email) throws ResourceNotFoundException {
+        authorizationService.addAdmin(id, email);
+        return Response.status(HttpStatus.OK.value()).entity(JsonUtils.createResponse("Role has been assigned").toString()).type(javax.ws.rs.core.MediaType.APPLICATION_JSON).build();
+    }
+
+    /**
+     * Unsubscribe from repo by email
+     */
+    @RequestMapping(method = RequestMethod.DELETE, path = "{id}/admins/{email:.+}")
+    @PreAuthorize("hasAnyAuthority('SUPER_ADMINISTRATOR', 'CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR') or @authorizationService.isMemberOf(#id)")
+    public ResponseEntity<Void> unsubscribeByEmail(@PathVariable("id") String id, @PathVariable("email") String email) throws ResourceNotFoundException {
+        authorizationService.removeAdmin(id, email);
+        return new ResponseEntity<>(HttpStatus.NO_CONTENT);
+    }
 }
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/domain/dto/Role.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/domain/dto/Role.java	(nonexistent)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/domain/dto/Role.java	(revision 61441)
@@ -0,0 +1,32 @@
+package eu.dnetlib.repo.manager.domain.dto;
+
+import javax.xml.bind.annotation.XmlRootElement;
+
+@XmlRootElement
+public class Role {
+    String name;
+    String description;
+
+    public Role() {}
+
+    public Role(String name, String description) {
+        this.name = name;
+        this.description = description;
+    }
+
+    public String getName() {
+        return name;
+    }
+
+    public void setName(String name) {
+        this.name = name;
+    }
+
+    public String getDescription() {
+        return description;
+    }
+
+    public void setDescription(String description) {
+        this.description = description;
+    }
+}
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/RepositoryService.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/RepositoryService.java	(revision 61440)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/RepositoryService.java	(revision 61441)
@@ -14,21 +14,38 @@
 public interface RepositoryService {
 
 
-    Country[] getCountries() ;
+    // TODO: move this elsewhere
+    Country[] getCountries();
 
+    List<Repository> getRepositories(List<String> ids) throws JSONException;
+
+    List<Repository> getRepositories(List<String> ids, int page, int size) throws JSONException;
+
+    List<RepositorySnippet> getRepositoriesSnippets(List<String> ids) throws Exception;
+
+    List<RepositorySnippet> getRepositoriesSnippets(List<String> ids, int page, int size) throws Exception;
+
     List<RepositorySnippet> getRepositoriesByCountry(String country, String mode, Boolean managed) throws JSONException, IOException;
 
+    // TODO: remove?
+    List<Repository> getRepositoriesOfUser(String page, String size) throws JSONException, IOException;
+
+    // TODO: remove?
     List<Repository> getRepositoriesOfUser(String userEmail,
                                            String page,
                                            String size) throws JSONException, IOException;
 
-    List<RepositorySnippet> getRepositoriesSnippetOfUser(String userEmail, String page, String size) throws IOException, JSONException;
+    List<RepositorySnippet> getRepositoriesSnippetsOfUser(String page, String size) throws Exception;
 
+    List<RepositorySnippet> getRepositoriesSnippetsOfUser(String userEmail, String page, String size) throws Exception;
+
+    RepositorySnippet getRepositorySnippetById(String id) throws JSONException, ResourceNotFoundException;
+
     Repository getRepositoryById(String id) throws JSONException, ResourceNotFoundException;
 
     List<AggregationDetails> getRepositoryAggregations(String id, int from, int size) throws JSONException;
 
-    Map<String,List<AggregationDetails>> getRepositoryAggregationsByYear(String id) throws JSONException;
+    Map<String, List<AggregationDetails>> getRepositoryAggregationsByYear(String id) throws JSONException;
 
     List<Repository> getRepositoriesByName(String name,
                                            String page,
@@ -35,8 +52,8 @@
                                            String size) throws JSONException;
 
     List<RepositorySnippet> searchRegisteredRepositories(String country, String typology, String englishName,
-                                                                String officialName, String requestSortBy, String order,
-                                                                int page, int pageSize) throws Exception;
+                                                         String officialName, String requestSortBy, String order,
+                                                         int page, int pageSize) throws Exception;
 
     List<RepositoryInterface> getRepositoryInterface(String id) throws JSONException;
 
@@ -59,7 +76,7 @@
 
     List<String> getUrlsOfUserRepos(String user_email,
                                     String page,
-                                    String size) throws JSONException;
+                                    String size);
 
     List<String> getDatasourceVocabularies(String mode);
 
@@ -71,7 +88,7 @@
 
     MetricsInfo getMetricsInfoForRepository(String repoId) throws RepositoryServiceException;
 
-    Map<String, String> getListLatestUpdate(String mode) throws RepositoryServiceException, JSONException;
+    Map<String, String> getListLatestUpdate(String mode) throws JSONException;
 
     RepositoryInterface updateRepositoryInterface(String repoId, String registeredBy, String comment, RepositoryInterface repositoryInterface) throws Exception;
 
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/PiWikController.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/PiWikController.java	(revision 61440)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/PiWikController.java	(revision 61441)
@@ -6,7 +6,6 @@
 import eu.dnetlib.repo.manager.domain.Paging;
 import eu.dnetlib.repo.manager.domain.RepositoryServiceException;
 import eu.dnetlib.repo.manager.service.PiWikServiceImpl;
-import eu.dnetlib.repo.manager.service.RepositoryService;
 import io.swagger.annotations.Api;
 import io.swagger.annotations.ApiImplicitParam;
 import io.swagger.annotations.ApiImplicitParams;
@@ -40,19 +39,15 @@
     @Autowired
     private PiWikServiceImpl piWikService;
 
-    @Autowired
-    private RepositoryService repositoryService;
-
-
     @RequestMapping(value = "/getPiwikSiteForRepo/{repositoryId}" , method = RequestMethod.GET,produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_ADMIN') or hasRole('ROLE_PROVIDE_ADMIN') or ((@repositoryService.getRepositoryById(#repositoryId).registeredBy==authentication.userInfo.email or @repositoryService.getRepositoryById(#repositoryId).registeredBy=='null') and hasRole('ROLE_USER'))")
+    @PreAuthorize("hasAnyRole('SUPER_ADMINISTRATOR', 'CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR') or @authorizationService.isMemberOf(#repositoryId) or (@repositoryService.getRepositoryById(#repositoryId).registeredBy=='null' and hasAuthority('REGISTERED_USER'))")
     public PiwikInfo getPiwikSiteForRepo(@PathVariable("repositoryId") String repositoryId) {
         return piWikService.getPiwikSiteForRepo(repositoryId);
     }
 
     @RequestMapping(value = "/savePiwikInfo" , method = RequestMethod.POST,produces = MediaType.APPLICATION_JSON_VALUE)
-    @PreAuthorize("hasRole('ROLE_ADMIN') or hasRole('ROLE_PROVIDE_ADMIN') or ((@repositoryService.getRepositoryById(#piwikInfo.repositoryId).registeredBy==authentication.userInfo.email or @repositoryService.getRepositoryById(#piwikInfo.repositoryId).registeredBy=='null') and hasRole('ROLE_USER'))")
+    @PreAuthorize("hasAnyRole('SUPER_ADMINISTRATOR', 'CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR') or @authorizationService.isMemberOf(#piwikInfo.repositoryId) or (@repositoryService.getRepositoryById(#piwikInfo.repositoryId).registeredBy=='null' and hasAuthority('REGISTERED_USER'))")
     public PiwikInfo savePiwikInfo(@RequestBody PiwikInfo piwikInfo) {
         return piWikService.savePiwikInfo(piwikInfo);
     }
@@ -154,7 +149,7 @@
 
     @RequestMapping(value = "/approvePiwikSite/{repositoryId}" , method = RequestMethod.GET)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_ADMIN') or hasRole('ROLE_PROVIDE_ADMIN')")
+    @PreAuthorize("hasAuthority('SUPER_ADMINISTRATOR') or hasAuthority('CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR')")
     public ResponseEntity<Object> approvePiwikSite(@PathVariable("repositoryId") String repositoryId) {
         return piWikService.approvePiwikSite(repositoryId);
     }
@@ -161,7 +156,7 @@
 
     @RequestMapping(value = "/getOpenaireId/{repositoryId}" , method = RequestMethod.GET,produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_ADMIN') or hasRole('ROLE_PROVIDE_ADMIN') or ((@repositoryService.getRepositoryById(#repositoryId).registeredBy==authentication.userInfo.email or @repositoryService.getRepositoryById(#repositoryId).registeredBy=='null') and hasRole('ROLE_USER'))")
+    @PreAuthorize("hasAnyRole('SUPER_ADMINISTRATOR', 'CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR') or @authorizationService.isMemberOf(#repositoryId) or (@repositoryService.getRepositoryById(#repositoryId).registeredBy=='null' and hasAuthority('REGISTERED_USER'))")
     public String getOpenaireId(@PathVariable("repositoryId") String repositoryId){
         return piWikService.getOpenaireId(repositoryId);
     }
@@ -169,7 +164,7 @@
     @RequestMapping(value = "/markPiwikSiteAsValidated/{repositoryId}" , method = RequestMethod.POST,
             consumes = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_ADMIN') or hasRole('ROLE_PROVIDE_ADMIN')")
+    @PreAuthorize("hasAuthority('SUPER_ADMINISTRATOR') or hasAuthority('CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR')")
     public ResponseEntity<Object> markPiwikSiteAsValidated(@PathVariable("repositoryId") String repositoryId) throws RepositoryServiceException {
         return piWikService.markPiwikSiteAsValidated(repositoryId);
     }
@@ -176,7 +171,7 @@
 
     @RequestMapping(value = "/enableMetricsForRepository", method = RequestMethod.POST,
             consumes = MediaType.APPLICATION_JSON_VALUE)
-    @PreAuthorize("hasRole('ROLE_ADMIN') or hasRole('ROLE_PROVIDE_ADMIN') or (hasRole('ROLE_USER') and #piwikInfo.requestorEmail == authentication.userInfo.email)")
+    @PreAuthorize("hasAuthority('SUPER_ADMINISTRATOR') or hasAuthority('CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR') or (hasAuthority('REGISTERED_USER') and #piwikInfo.requestorEmail == authentication.userInfo.email)")
     public PiwikInfo enableMetricsForRepository(@RequestParam("officialName") String officialName,
                                                 @RequestParam("repoWebsite") String repoWebsite,
                                                 @RequestBody PiwikInfo piwikInfo) throws RepositoryServiceException {
